// PluginTestDlg.cpp : implementation file
//

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

#include "stdafx.h"
#include "resource.h"
#include "CustomPlugin.h"
#include "PluginTestDlg.h"
#include "dbg.h"
#include "Mach3ObjectModel.h"

#include "Mach3DRO.h"
#include "Mach3Button.h"
#include "Mach3Led.h"

#include "CMyScriptObject.h"
#include ".\plugintestdlg.h"
extern CMyScriptObject scripter;

// CPluginTestDlg dialog

IMPLEMENT_DYNAMIC(CPluginTestDlg, CDialog)
CPluginTestDlg::CPluginTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPluginTestDlg::IDD, pParent)
{
}

CPluginTestDlg::~CPluginTestDlg()
{
}

void CPluginTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CPluginTestDlg, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_RESET, OnBnClickedReset)
	ON_BN_CLICKED(IDC_LOAD_RR, OnBnClickedLoadRr)
	ON_BN_CLICKED(IDC_RUN_RR, OnBnClickedRunRr)
	ON_BN_CLICKED(IDC_HOOK_INSTALL, OnBnClickedHookInstall)
	ON_BN_CLICKED(IDC_HOOK_REMOVE, OnBnClickedHookRemove)
END_MESSAGE_MAP()


// CPluginTestDlg message handlers

//void Hook_KeyboardEvent(Kennedy.ManagedHooks.KeyboardEvents kEvent, Keys key)
//{
//
//}


void CPluginTestDlg::OnBnClickedOk()
{
	DbgMsg(("OnBnClickedOk entry"));
	ShowWindow(SW_HIDE);
	DbgMsg(("OnBnClickedOk exit"));
}

void CPluginTestDlg::OnBnClickedCancel()
{
	DbgMsg(("OnBnClickedCancel entry"));
	ShowWindow(SW_HIDE);
	DbgMsg(("OnBnClickedCancel exit"));
}

void CPluginTestDlg::OnBnClickedReset()
{
	DoButton(MACH3_RESET);    // Reset (1021)
}

void CPluginTestDlg::OnBnClickedLoadRr()
{
	Mach3ObjectModelStartup();
	//scripter.LoadFile("C:\\Mach3\\Gcode\\RoadRunner.tap");
	LoadGcodeFile("C:\\Mach3\\Gcode\\RoadRunner.tap");
	Mach3ObjectModelShutdown();
}

void CPluginTestDlg::OnBnClickedRunRr()
{
	DoButton(CYCLE_START);    // Cycle Start (1000)
}

void CPluginTestDlg::OnBnClickedHookInstall()
{
	//  Install Keyboard Hook
	DbgMsg(("keyboardHook Installed"));
	
	//keyboardHook.InstallHook();
}

void CPluginTestDlg::OnBnClickedHookRemove()
{
	//  Remove Keyboard Hook
	DbgMsg(("keyboardHook Removed"));
	
	//keyboardHook.UninstallHook();
	//keyboardHook = NULL;
}